#include "RHB_Custom.h"

ClassImp (RHB_Custom)

void  RHB_Custom::InitParams (void)
{
	Quanta_count=0;
   Mean_charge=0.;

	FEventProcessorThread::InitParams ();       // call official function
						    // and add user specific part :

	this->tcount = GetParam("myScaler_COUNT_t");  // get a param already declared
   this->Count  = GetParam("myScaler_ACC_QUANTA");
   this->t0c    = this->tcount->GetValue();
   this->t1c    = this->tcount->GetValue();

	this->Time_COUNT  = new FParamBrutSimple ();  // create new params
   this->Time_COUNT->SetName("Time_COUNT");
	this->AddRawParam (this->Time_COUNT);
}

void RHB_Custom::SetParamValues (void)
{
	FEventProcessorThread::SetParamValues ();     //  call official function

	if(this->Count->IsOn()) Quanta_count=this->Count->GetValue();

        if(this->tcount->IsOn())
        {
                if(this->t0c<0) this->t0c=this->tcount->GetValue();
                if(this->t1c<0) this->t1c=this->tcount->GetValue();
                if(this->tcount->GetValue()-this->t1c>=1.0e9)
                {
                        this->t1c=this->tcount->GetValue();
                        this->Time_COUNT->SetValue((this->tcount->GetValue()-this->t0c)/1E9);
                        if(Quanta_count>0&&Mean_charge>0.)
                                cout << "Calibration ratio: " << Mean_charge/2. << "/"<<Quanta_count << "="<< Mean_charge/(2.*Quanta_count) << " pC/part" << endl;
                }
        }


}


